#ifndef __BSCAN_H__
#define __BSCAN_H__

#define JTAG_DYNAMIC_DRIVER 1

/* JTAG Boundary Scan External RAW Access Function */
#if JTAG_DYNAMIC_DRIVER
extern int (*jtag_txrx)(const BYTE *ibuf,BYTE *obuf,DWORD drsize,int tms_s,int tms_e);
#else
extern int jtag_txrx(const BYTE *ibuf,BYTE *obuf,DWORD drsize,int tms_s,int tms_e);
#endif

extern int bscan_num_chain;		// number of daisy chain chips
extern int bscan_tdo_chips;		// number of chips in TDO side for target
extern int bscan_tdo_ir;			// number of total IR bits in back chain
extern int bscan_tdi_ir;			// number of total IR bits in TDI side chain
extern int bscan_tdi_bypass;		// number of chips in TDI side chain
extern int bscan_tdo_bypass;		// number of chips in TDO side chain
extern int bscan_before_dr;		// pre-shift  dummy shift before DR transfer
extern int bscan_after_dr;		// post-shift dummy shift after  DR transfer

int bscan_reset(int num_tck);
int bscan_inst(BYTE cmd,const BYTE *ibuf,BYTE *obuf,int drsize,int finish);
int bscan_dr(const BYTE *ibuf,BYTE *obuf,int drsize,int finish);

int bscan_scan_chain(void);
int bscan_device_autoditect(DWORD deviceid);

#endif
