#ifndef __JTAGFW_H__
#define __JTAGFW_H__

#define JTAGFW_CPIPE 0 // Ep1IN : Controll Pipe (EP1IN)
#define JTAGFW_WPIPE 1 // Ep2IN : WriteToJTAG , JTAGclock/byte
#define JTAGFW_DPIPE 3 // Ep4IN : WriteToJTAG with Readback , (read RPIPE in every one packet.)
#define JTAGFW_RPIPE 8 // Ep2OUT: Read , JtagRead , status , etc.

#define JTAGFW_CDIR 0x00 // 2:0 (cmd)(PCdir) PortC Direction set
#define JTAGFW_CSET 0x10 // 2:0 (cmd)(PCout) PortC Outport
#define JTAGFW_CGET 0x20 // 1:1 (cmd)->(PCin) , PortC Input
#define JTAGFW_XMW  0x30 // 3:0 (cmd)(ad[7..0])(ad[15..8])(xdata) Write XDATA
#define JTAGFW_XMR  0x40 // 2:1 (cmd)(ad[7..0])(ad[15..8])->(xdata) Read XDATA
#define JTAGFW_READ 0x50 // 3:? (cmd)(LEN[5..0])(LEN[13..6]),(LEN[21..14])->(FREAD)xLEN
#define	JTAGFW_BUS  0xf0 // 2:0 (cmd,strech)(FASTXFR) set bus mode

extern unsigned char firmware[];
#endif

