/****************************************************************************
	Xilinx SpartanII(/vertex) CCLK Configration Controller

	Copyright(c) 2003 Tatsuyuki Satoh

	note:

	Histry
		2002. 3.11 separated from spcisp.c

****************************************************************************/
#include <windows.h>
#include <stdio.h>

#include "xcclk.h"

#if XCCLK_DYNAMIC_DRIVER
int (*xcclk_tx)(const BYTE *data,DWORD size_bytes); /* TX configration data  */
int (*xcclk_program)(BYTE level);                   /* controll -PROGRAM pin */
int (*xcclk_done)(void);                            /* sense DONE pin        */
#endif

/****************************************************************************/
/* Start Configration                                                       */
/****************************************************************************/
int xcclk_start(DWORD deviceid)
{
	/* PROGRAM = L */
	xcclk_program(0);
	sleep(50);
	/* PROGRAM = H */
	xcclk_program(1);
	/* (wait for INIT=H) */
	sleep(50);

	return 0;
}

/****************************************************************************/
/* BlockWrite                                                               */
/****************************************************************************/
int xcclk_write(BYTE *data,DWORD size,int last)
{
	xcclk_tx(data,size);

	if(last)
	{
		/* Check DONE pin */
		if( xcclk_done() )
		{
/*			printf("DONE = H\n"); */
			return 0;
		}
		else
		{
/*			printf("DONE = L\n"); */
			return 1;
		}
	}

	return 0;
}

